Subject: Re: [PATCH net-next] tcp: try to defer / return acked skbs to originating CPU

From: Jakub Kicinski <[email-masked]>
Date: Mon, 16 Feb 2026 09:49:36 -0800

On Mon, 16 Feb 2026 17:06:58 +0100 Eric Dumazet wrote:
> > > Looks like selftests run into the zerocopy Tx latency issue.
> > > I'll drop this version from patchwork..  
> >
> > Delaying zero copy forever is a bit of an annoyance.
> > I believe the same thing can happen in net-next with UDP
> > but I haven't tested to confirm.
> >
> > I assume the attached patch is out of question since it came up before?  
> 
> I think I totally missed your email :/
> 
> What about not attempting defer for zero copy skbs ?
> 
> It turns out existing patch e20dfbad8aab ("net: fix napi_consume_skb()
> with alien skbs") is already a problem for zcopy.

We definitely need either this or the timer patch I attached, for UDP.

I put the TCP write side on a back burner because slab sheaves got
merged, I think skb defer free will still make a difference but IDK 
how much. Maybe juice will no longer be worth the squeeze?